<?php
class ControllerExtensionModuleRouteeNewsletterSubscribers extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/newsletter_subscribers');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/newsletter_subscribers', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}

		if( 1 == $this->config->get('module_routee_newsletter_exported') ) {
			$data['newsletter_exists'] = 0;
		} else {
			$data['newsletter_exists'] = 1;
		}
		
		$data['token'] = $this->session->data['token'];
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/newsletter_subscribers/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/newsletter_subscribers/insert_mass', 'token=' . $this->session->data['token'], true));
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/newsletter_subscribers', $data));

	}
	
	public function insert_mass() {
		$this->load->language('extension/module/routee/newsletter_subscribers');
		
		if($this->config->get('module_routee_uuid') != "")
		{
            $this->load->model('customer/customer');
            $sort = 'name';
            $order = 'ASC';

            $filter_data = array(
                'filter_newsletter'		   => '1',
                'sort'                     => $sort,
                'order'                    => $order,
            );

            $customerData = $this->model_customer_customer->getCustomers($filter_data);
            $customerInfo = array();
			
			if($customerData) {
                $t_count = count($customerData);
                $c_count = $count = 0;
				unset($this->session->data['newsletter_not_exists']);
				foreach($customerData as $k => $customerRow) {
                    $count++;
                    $c_count++;
					$customerInfo[] = array('email' => $customerRow['email']);
                    if ($count == 100 || $c_count == $t_count) {
                        $resultJson = $this->send_data($customerInfo);
                        $customerInfo = [];
                        $count = 0;
                    }
				}
				
				if(isset($resultJson)) {
					if(!empty($resultJson['message'])) {
						
						$this->session->data['success'] =  $this->language->get('text_success');
						$this->load->model('setting/setting');
						$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_newsletter_exported', 1);
					} else {
						$this->session->data['error_warning'] = $this->language->get('text_error');
					}
				} else {
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
				}
			} else {
				$this->session->data['newsletter_not_exists'] = 1;
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
			}
		} else {
            $this->session->data['error_warning'] = $this->language->get('text_error');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/newsletter_subscribers', 'token=' . $this->session->data['token'], true));
	}

    public function send_data($customerInfo) {
        $data["uuid"] = $this->config->get('module_routee_uuid');
        $data['data'][0] = array(
            'name' => 'Newsletter Subscribers',
            'description' => 'Shop Newsletter Subscribers',
            'object' => $customerInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Newsletter Subscribers: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
