<?php
class ControllerExtensionModuleRouteeProducts extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/products');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/products', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		if( 1 == $this->config->get('module_routee_product_exported') ) {
			$data['product_exists'] = 0;
		} else {
			$data['product_exists'] = 1;
		}
		
		$data['token'] = $this->session->data['token'];
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/products/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/products/insert_mass', 'token=' . $this->session->data['token'], true));

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/products', $data));
	}

    public function insert_mass() {

        $this->load->language('extension/module/routee/products');

        if($this->config->get('module_routee_uuid') != "") {

            $this->load->model('catalog/product');
            $this->load->model('catalog/category');
            $sort = 'pd.name';
            $order = 'ASC';
            $filter_data = array(
                'sort'            => $sort,
                'order'           => $order,
            );

            $productData = $this->model_catalog_product->getProducts($filter_data);
            $productInfo = array();

            if($productData) {
                $t_count = count($productData);
                $c_count = $count = 0;
                unset($this->session->data['products_not_exists']);
                foreach($productData as $k => $productRow) {
                    $count++;
                    $c_count++;
                    $searchProduct = array();
                    $special = false;
                    $product_specials = $this->model_catalog_product->getProductSpecials($productRow['product_id']);

                    foreach ($product_specials  as $product_special) {
                        if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
                            $special = $product_special['price'];
                            break;
                        }
                    }

                    $category = array();

                    $categories = $this->model_catalog_product->getProductCategories($productRow['product_id']);

                    foreach ($categories as $category_id) {
                        $category_info = $this->model_catalog_category->getCategory($category_id);

                        if ($category_info) {
                            $category[] = $category_info['name'];
                        }
                    }

                    $image_link = $product_link = "";

                    if (isset($productRow['image'])) {
                        $image_link = HTTP_CATALOG.$productRow['image'];
                    }

                    $product_link = HTTP_CATALOG.'index.php?route=product/product&product_id='.$productRow['product_id'];

                    $discount = array();

                    $product_discounts = $this->model_catalog_product->getProductDiscounts($productRow['product_id']);

                    foreach ($product_discounts as $product_discount) {
                        $discount[] = array(
                            'price'             => $this->tax->calculate($product_discount['price'], $productRow['tax_class_id'], $this->config->get('config_tax')),
                            'quantity'          => $product_discount['quantity'],
                            'date_start'        => ($product_discount['date_start'] != '0000-00-00') ? $product_discount['date_start'] : '',
                            'date_end'          => ($product_discount['date_end'] != '0000-00-00') ? $product_discount['date_end'] : ''
                        );
                    }

                    $product_description = $this->model_catalog_product->getProductDescriptions($productRow['product_id']);

                    if($special) {
                        $price = $special;
                    } else {
                        $price = $productRow['price'];
                    }

                    foreach ($product_description as $language_id => $value) {
                        $searchProduct = array(
                            'product_id' => $productRow['product_id'],
                            'name' => $value['name'],
                            'description' => html_entity_decode($value['description'], ENT_QUOTES, 'UTF-8'),
                            'categories' => $category,
                            'stock_quantity' => $productRow['quantity'],
                            'price' => $this->tax->calculate($price, $productRow['tax_class_id'], $this->config->get('config_tax')),
                            'discount' => $discount,
                            'image_link' => $image_link,
                            'product_link' => $product_link
                        );
                    }
                    $productInfo[] = $searchProduct;

                    if ($count == 100 || $c_count == $t_count) {
                        $resultJson = $this->send_data($productInfo);
                        $productInfo = [];
                        $count = 0;
                    }
                }

                if( isset($resultJson) ) {
                    if(!empty($resultJson['message'])) {
                        $this->session->data['success'] = $this->language->get('text_success');
                        $this->load->model('setting/setting');
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_product_exported', 1);
                    } else {
                        $this->session->data['error_warning'] = $this->language->get('text_error');
                    }
                } else {
                    $this->session->data['error_warning'] = $this->language->get('text_not_imported');
                }
            } else {
                $this->session->data['products_not_exists'] = 1;
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
            }
        } else {
            $this->session->data['error_warning'] = $this->language->get('text_error');
        }

        $this->response->redirect($this->url->link('extension/module/routee/products', 'token=' . $this->session->data['token'], true));
    }

    public function send_data($productInfo) {

        $data["uuid"] = $this->config->get('module_routee_uuid');
        $data['data'][0] = array(
            'name' => 'Products',
            'description' => 'Shop Products',
            'object' => $productInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Products: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
