<?php
class ControllerExtensionModuleRouteeWishlist extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/wishlist');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/wishlist', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		if( 1 == $this->config->get('module_routee_wishlist_exported') ) {
            $data['wishlist_exists'] = 0;
		} else {
			$data['wishlist_exists'] = 1;
		}
		
		$data['token'] = $this->session->data['token'];
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/wishlist/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/wishlist/insert_mass', 'token=' . $this->session->data['token'], true));

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/wishlist', $data));

	}
	
	public function insert_mass() {
		$this->load->language('extension/module/routee/wishlist');
		
		if($this->config->get('module_routee_uuid') != "") {

            $this->load->model('customer/customer');
            $this->load->model('extension/module/customer_wishlist');
            $sort = 'name';
            $order = 'ASC';

            $filter_data = array(
                'sort'   => $sort,
                'order'  => $order
            );
            $customerData = $this->model_customer_customer->getCustomers($filter_data);
            $customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();

			$wishlistInfo = array();
			
			if($customerData && $customerWishlist) {
                $t_count = count($customerWishlist);
                $c_count = $count = 0;
				unset($this->session->data['wishlist_not_exists']);
				foreach($customerData as $k => $customerRow) {
					$customerID = $customerRow['customer_id'];
					
					$customerWishlistData = $this->model_extension_module_customer_wishlist->getWishlist($customerID);
					if($customerWishlistData) {
						foreach($customerWishlistData as $k1 => $customerWishlistRow) {
                            $count++;
                            $c_count++;
							unset($customerWishlistRow['date_added']);
							$wishlistInfo[] = $customerWishlistRow;
                            if ($count == 100 || $c_count == $t_count) {
                                $resultJson = $this->send_data($wishlistInfo);
                                $wishlistInfo = [];
                                $count = 0;
                            }
						}
					}
				}
				
				if(isset($resultJson)) {
					if(!empty($resultJson['message'])) {
                        $this->session->data['success'] =  $this->language->get('text_success');
						$this->load->model('setting/setting');
						$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_wishlist_exported', 1);
					} else {
						$this->session->data['error_warning'] = $this->language->get('text_error');
					}
				} else {
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
				}
			} else {
				$this->session->data['wishlist_not_exists'] = 1;
                $this->session->data['error_warning'] = $this->language->get('text_not_exists');
			}
		} else {
            $this->session->data['error_warning'] = $this->language->get('text_error');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/wishlist', 'token=' . $this->session->data['token'], true));
	}

    public function send_data($wishlistInfo) {
        $data["uuid"] = $this->config->get('module_routee_uuid');
        $data['data'][0] = array(
            'name' => 'Wishlist',
            'description' => 'Shop Wishlists',
            'object' => $wishlistInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Wishlist: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
